blob: 5ac8abffbf1f0fc0db2b4c642604362a602244ea [file] [log] [blame]
Yegor Timoshenkoc2e49412018-10-07 01:58:27 +00001#!/usr/bin/env bash
Martin Rothbec11082015-11-03 21:01:53 -07002#
Patrick Georgi7333a112020-05-08 20:48:04 +02003# SPDX-License-Identifier: GPL-2.0-only
Martin Rothbec11082015-11-03 21:01:53 -07004
Martin Rothfb190ed2016-10-01 20:13:43 -06005# This script creates a list of commits between two releases, broken out into
6# fairly inexact categories, based on the directories that files are in. If
7# a commit touched anything in the path that is checked earlier, it's counted
8# as being in that category.
9#
10# Don't run this in your current working tree, it checks out different versions
11# and can lose things.
Martin Rothbec11082015-11-03 21:01:53 -070012
Martin Rothfb190ed2016-10-01 20:13:43 -060013# set -x # uncomment for debug
14
15# Check for tools
16
Patrick Georgifa13a642018-12-20 17:17:03 +010017if ! ( git --version && cloc --version && rename --version ) > /dev/null 2>&1
Martin Rothfb190ed2016-10-01 20:13:43 -060018then
Martin Rotheb80d8d2022-02-28 14:41:57 -070019 echo "ERROR: cloc, git or rename is not installed. Exiting" >&2
Martin Rothbec11082015-11-03 21:01:53 -070020 exit 1
21fi
22
Alex Thiessenda384dd2018-01-13 16:31:28 +000023if ! { cdup="$(git rev-parse --show-cdup 2>/dev/null)" && [ -z "${cdup}" ]; }
24then
Martin Rotheb80d8d2022-02-28 14:41:57 -070025 echo "ERROR: This is not the top directory of a git repo. Exiting." >&2
Martin Rothfb190ed2016-10-01 20:13:43 -060026 exit 1
27fi
28
29# Try to verify that the repo is clean before losing state.
Martin Rotheb80d8d2022-02-28 14:41:57 -070030if ! git diff-index --quiet --cached HEAD 2>/dev/null || \
Stefan Reinauer0d3a1fb2023-06-10 12:32:50 -070031 [ "$(git diff origin/main --shortstat 2>/dev/null | tail -n1)" != "" ]; then
Martin Rotheb80d8d2022-02-28 14:41:57 -070032 echo "ERROR: repo is not clean. Exiting." >&2
Martin Rothbec11082015-11-03 21:01:53 -070033 exit 1
34fi
35
Martin Rothfb190ed2016-10-01 20:13:43 -060036# Verify the command line arguments
37if [ "$1" == "--help" ] || [ -z "$1" ] || [ -z "$2" ]; then
38 echo
39 echo "Usage: $0 <old_version> <new_version> [release notes file]"
40 echo "Old version should be a tag (4.1), a branch (origin/4.1), or a commit id"
Stefan Reinauer0d3a1fb2023-06-10 12:32:50 -070041 echo "New version can be a branch (origin/main) a tag (4.2), or a commit id"
Martin Rothfb190ed2016-10-01 20:13:43 -060042 echo "Logfile can be a new file or an existing file to update"
43 echo "Example: \"$0 origin/4.1 4.2 rnotes.txt\""
44 echo
45 echo "Note that the script starts at the commit AFTER the old version."
46 echo
47 exit 1
48else
49 OLD_GIT_VERSION="$1"
50 NEW_GIT_VERSION="$2"
Martin Rotheb80d8d2022-02-28 14:41:57 -070051 if [[ "$OLD_GIT_VERSION" = "HEAD" || "$NEW_GIT_VERSION" = "HEAD" ]]; then
52 echo "Error: using HEAD as a reference doesn't work" >&2
Patrick Georgi81a30ec2020-05-11 23:47:12 +020053 echo
54 exit 1
55 fi
Martin Rothfb190ed2016-10-01 20:13:43 -060056 TOTAL_COMMITS=$(git log --pretty=oneline \
57 "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | wc -l)
58fi
59
60TOP=$(pwd)
61
62if [ -n "$3" ]; then
63 MAIN_LOGFILE="${TOP}/$3"
64else
65 MAIN_LOGFILE="${TOP}/relnotes.txt"
66fi
67
68# Figure out which logfile we're writing to. If the specified logfile exists,
69# we need to write to a temporary logfile, then append changes to the main
70# logfile.
Martin Rothbec11082015-11-03 21:01:53 -070071if [ -f "$MAIN_LOGFILE" ]; then
72 LOGFILE="$(mktemp "LOGFILE.XXXX")"
73 LOGFILE="${TOP}/$LOGFILE"
74 UPDATE_MAIN_LOGFILE=1
75else
76 LOGFILE="$MAIN_LOGFILE"
77fi
78
Martin Rothfb190ed2016-10-01 20:13:43 -060079get_author_commit_count() {
80 git log "${NEW_GIT_VERSION}" 2>/dev/null | grep -c "^Author: $1"
81}
82
83# Print and log the versions
Martin Rothbec11082015-11-03 21:01:53 -070084log_versions() {
85 echo "Log of commit $1 to commit $2"
86 echo "Log of commit $1 to commit $2" >> "$LOGFILE"
Martin Rothfb190ed2016-10-01 20:13:43 -060087 echo "Total commits: ${TOTAL_COMMITS}"
88 echo "Total commits: ${TOTAL_COMMITS}" >> "$LOGFILE"
Martin Rothbec11082015-11-03 21:01:53 -070089 echo
90}
91
Martin Rothfb190ed2016-10-01 20:13:43 -060092# Get the first commit id in the current tree
Martin Rothbec11082015-11-03 21:01:53 -070093get_latest_commit_id() {
Martin Roth3ce67832017-11-04 18:36:19 -060094(
Martin Rotheb80d8d2022-02-28 14:41:57 -070095 cd "$1" || exit 1
96 git log -n 1 2>/dev/null | grep '^commit ' | head -1 | sed 's/commit //' | sed 's/ .*//'
Martin Roth3ce67832017-11-04 18:36:19 -060097)
Martin Rothbec11082015-11-03 21:01:53 -070098}
99
Martin Rothfb190ed2016-10-01 20:13:43 -0600100# Main get log function
Martin Rothbec11082015-11-03 21:01:53 -0700101_get_log() {
102 local oldver="$1"
103 local newver="$2"
104 local title="$3"
105 local paths="$4"
Martin Roth3ce67832017-11-04 18:36:19 -0600106 local keywords="$5"
Martin Rothbec11082015-11-03 21:01:53 -0700107
Martin Roth3ce67832017-11-04 18:36:19 -0600108 # Leave ${paths} unquoted in the git commands
Martin Rothfb190ed2016-10-01 20:13:43 -0600109 # shellcheck disable=SC2086
Martin Roth3ce67832017-11-04 18:36:19 -0600110 { \
111 if [ -n "$paths" ]; then \
112 git log --abbrev-commit --pretty=oneline \
113 "${oldver}..${newver}" -- ${paths} \
114 2>/dev/null; \
115 fi; \
116 if [ -n "$keywords" ]; then \
117 git log --abbrev-commit --pretty=oneline \
118 "${oldver}..${newver}" 2>/dev/null \
119 | grep -i "$keywords"; \
120 fi \
121 } | sort -t ' ' -k 2 | uniq
Martin Rothbec11082015-11-03 21:01:53 -0700122}
123
Martin Rothfb190ed2016-10-01 20:13:43 -0600124# Output to a new log, then compare to the first logfile, and only output
125# non duplicated lines to the final file.
Martin Rothbec11082015-11-03 21:01:53 -0700126get_log_dedupe() {
127 local title="$1"
128 local paths="$2"
Martin Roth3ce67832017-11-04 18:36:19 -0600129 local keywords="$3"
Martin Rothfb190ed2016-10-01 20:13:43 -0600130 local log
131 local commits
132
Martin Rothbec11082015-11-03 21:01:53 -0700133 dedupe_tmpfile="$(mktemp "LOGFILE.XXXX")"
134
Martin Rothfb190ed2016-10-01 20:13:43 -0600135 log=$(_get_log "$OLD_GIT_VERSION" "$NEW_GIT_VERSION" \
Martin Roth3ce67832017-11-04 18:36:19 -0600136 "$title" "$paths" "$keywords")
Martin Rothbec11082015-11-03 21:01:53 -0700137
138 echo "$log" > "$dedupe_tmpfile"
139
140 log=$(grep -Fxv -f "$LOGFILE" "$dedupe_tmpfile")
Martin Rothfb190ed2016-10-01 20:13:43 -0600141 commits=$(echo "$log" | wc -l)
Martin Rothbec11082015-11-03 21:01:53 -0700142
Martin Rotheb80d8d2022-02-28 14:41:57 -0700143 if [ -n "$log" ]; then
144 #echo "$title: $paths $keywords" >> "$LOGFILE"
145 printf "%s\n%s\n\n" "##### $title ($commits commits) #####" \
146 "$log" >> "$LOGFILE"
147 fi
Martin Rothbec11082015-11-03 21:01:53 -0700148
149 rm "$dedupe_tmpfile"
150}
151
152# get logs for the submodules
153get_log_submodule() {
154 local old_version="$1"
155 local new_version="$2"
156 local submodule_dir="$3"
Martin Rothfb190ed2016-10-01 20:13:43 -0600157 local log
158 local commits
Martin Rothbec11082015-11-03 21:01:53 -0700159
160 printf "Submodule %s\n" "$submodule_dir"
161 printf "commit %s to commit %s\n\n" "$old_version" "$new_version"
162
Martin Rotheb80d8d2022-02-28 14:41:57 -0700163 if ! (
164 cd "${TOP}/$submodule_dir" || exit 1
165 log="$(_get_log "$old_version" "$new_version" "$submodule_dir" "." "")" || exit 1
Martin Rothfb190ed2016-10-01 20:13:43 -0600166 commits=$(echo "$log" | wc -l)
Martin Rothbec11082015-11-03 21:01:53 -0700167
168 if [ -n "$log" ]; then
Martin Rothcbc792c2023-08-20 19:21:55 -0600169 printf "* %s: Update from commit id %s to %s (%s commits)\n" "${submodule_dir}" "${old_version:0:10}" "${new_version:0:10}" "${commits}" >> "$LOGFILE"
Martin Rothbec11082015-11-03 21:01:53 -0700170 fi
Martin Rotheb80d8d2022-02-28 14:41:57 -0700171 ); then
172 version_ctrl_c
173 fi
Martin Rothbec11082015-11-03 21:01:53 -0700174}
175
Martin Rothfb190ed2016-10-01 20:13:43 -0600176find_areas() {
Martin Roth3ce67832017-11-04 18:36:19 -0600177 local directory="$1"
178 local filename="$2"
179 local skip="$3"
180 find "$directory" -name "$filename" | sed "s|/$filename||" | sed "s|/$directory||" | grep -v "$skip" | sort
Martin Rothfb190ed2016-10-01 20:13:43 -0600181}
182
183# Make sure things get cleaned up if ctl-c is pressed while the old version
184# is checked out and files are renamed. This can be a real mess to clean
185# up manually.
Martin Rothbec11082015-11-03 21:01:53 -0700186version_ctrl_c() {
Martin Rotheb80d8d2022-02-28 14:41:57 -0700187 printf "\n Cleaning up and exiting.\n" >&2
Stefan Reinauer0d3a1fb2023-06-10 12:32:50 -0700188 git checkout origin/main > /dev/null 2>&1
Martin Rothbec11082015-11-03 21:01:53 -0700189 git submodule update --init --checkout > /dev/null 2>&1
Martin Rothbec11082015-11-03 21:01:53 -0700190 rm "$LOGFILE"
191 exit 1;
192}
193
Martin Rothfb190ed2016-10-01 20:13:43 -0600194# Calculate areas that have been added or removed based on file lists
195show_diff () {
196 local new
197 local old
Martin Rothbec11082015-11-03 21:01:53 -0700198
Patrick Georgi1916d682019-11-20 16:05:21 +0100199 new="$(comm -13 <(echo "$2") <(echo "$3"))"
200 old="$(comm -23 <(echo "$2") <(echo "$3"))"
201
202 # Allow running a postprocessor, given as 4th argument over the
203 # resulting diff, provide context if it's old or new data
204 if [ -n "$4" ]; then
205 new=$(echo "$new" | $4 new | sort)
206 old=$(echo "$old" | $4 old | sort)
207 fi
Martin Rotheb80d8d2022-02-28 14:41:57 -0700208 new="$(printf "%s" "$new" | sed 's/^/* /')"
209 old="$(printf "%s" "$old" | sed 's/^/* /')"
Patrick Georgi1916d682019-11-20 16:05:21 +0100210
Martin Rothfb190ed2016-10-01 20:13:43 -0600211 if [ -n "$new" ]; then
212 printf "Added %s $1:\n-------------------\n%s\n\n" \
213 "$(echo "$new" | wc -l)" "$new" >> "$LOGFILE"
214 fi
Martin Rothfb190ed2016-10-01 20:13:43 -0600215 if [ -n "$old" ]; then
216 printf "Removed %s $1:\n-------------------\n%s\n\n" \
217 "$(echo "$old" | wc -l)" "$old" >> "$LOGFILE"
218 fi
219}
220
Martin Roth3ce67832017-11-04 18:36:19 -0600221get_sloc () {
Martin Rotheb80d8d2022-02-28 14:41:57 -0700222 local base
223 base=$(mktemp)
Martin Roth3ce67832017-11-04 18:36:19 -0600224
Patrick Georgi436296b2019-11-20 17:15:13 +0100225 cloc --progress-rate=0 --quiet \
226 --script-lang="Bourne Shell",bash --exclude-ext=inc \
Martin Rotheb80d8d2022-02-28 14:41:57 -0700227 --exclude-dir=vendorcode "--out=${base}" src
Patrick Georgi436296b2019-11-20 17:15:13 +0100228 cloc --progress-rate=0 --quiet \
Martin Roth50e85792024-01-18 19:10:50 -0700229 "--exclude-list-file=${base}.mk" --force-lang=c,inc \
Martin Rotheb80d8d2022-02-28 14:41:57 -0700230 --exclude-dir=vendorcode "--out=${base}.c" src
Patrick Georgi436296b2019-11-20 17:15:13 +0100231 cloc --progress-rate=0 --quiet \
Martin Roth50e85792024-01-18 19:10:50 -0700232 "--list-file=${base}.mk" --force-lang=make,inc \
Martin Rotheb80d8d2022-02-28 14:41:57 -0700233 --exclude-dir=vendorcode "--out=${base}.m" src
Patrick Georgi436296b2019-11-20 17:15:13 +0100234 cloc --progress-rate=0 --quiet --sum-reports \
Martin Rotheb80d8d2022-02-28 14:41:57 -0700235 "${base}" "${base}.c" "${base}.m" --out "${base}.result"
Patrick Georgi436296b2019-11-20 17:15:13 +0100236
237 echo
Martin Rotheb80d8d2022-02-28 14:41:57 -0700238 cat "${base}.result.lang"
Patrick Georgi436296b2019-11-20 17:15:13 +0100239
Martin Rotheb80d8d2022-02-28 14:41:57 -0700240 rm -f "${base}"*
Martin Roth3ce67832017-11-04 18:36:19 -0600241}
242
Martin Rothfb190ed2016-10-01 20:13:43 -0600243# Start collecting data from the old and new revisions.
244# This is relatively disruptive to the tree, so trap on ctl-c so that
245# things can be put back to normal
246trap version_ctrl_c SIGINT
Martin Rothbec11082015-11-03 21:01:53 -0700247
248#check out old version and get information
Martin Rotheb80d8d2022-02-28 14:41:57 -0700249echo "Finding old submodule versions..." >&2
Martin Rothfb190ed2016-10-01 20:13:43 -0600250git checkout "$OLD_GIT_VERSION" > /dev/null 2>&1
Martin Rotheb80d8d2022-02-28 14:41:57 -0700251echo "Git version: $(git log --oneline -n 1)"
Martin Rothbec11082015-11-03 21:01:53 -0700252git submodule update --init --checkout > /dev/null 2>&1
Martin Roth3ce67832017-11-04 18:36:19 -0600253for module in $(git submodule --quiet foreach pwd); do
254 name="$(basename "$module" | sed 's/-/_/g')"
255 version="${name^^}_OLD_VERSION"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700256 declare "$version"="$(get_latest_commit_id "$module")"
Martin Roth3ce67832017-11-04 18:36:19 -0600257done
Martin Rothfb190ed2016-10-01 20:13:43 -0600258
Martin Rotheb80d8d2022-02-28 14:41:57 -0700259printf "Logging directories in the old tree\n" >&2
Martin Roth3ce67832017-11-04 18:36:19 -0600260mainboard_list_old=$(grep -h "^[[:space:]]*config\>[[:space:]]*\<BOARD_" src/mainboard/*/*/Kconfig.name 2>/dev/null | sed "s,^.*\<BOARD_\([A-Z0-9_]*\)\>.*$,\1," | sort)
261cpu_list_old=$(find_areas "src/cpu" "Kconfig" "intel/common")
Martin Roth50e85792024-01-18 19:10:50 -0700262soc_list_old=$(find_areas "src/soc" "Makefile.mk" "intel/common\|amd/common\|romstage")
Martin Roth3ce67832017-11-04 18:36:19 -0600263northbridge_list_old=$(find_areas "src/northbridge" "Kconfig" "")
Martin Roth50e85792024-01-18 19:10:50 -0700264sio_list_old=$(find_areas "src/superio" "Makefile.mk" "")
Martin Roth3ce67832017-11-04 18:36:19 -0600265southbridge_list_old=$(find_areas "src/southbridge" "Kconfig" "")
Martin Rothfb190ed2016-10-01 20:13:43 -0600266
Martin Rotheb80d8d2022-02-28 14:41:57 -0700267echo "Calculating old SLOC"
Martin Roth3ce67832017-11-04 18:36:19 -0600268OLD_SLOC=$(get_sloc)
Martin Rothbec11082015-11-03 21:01:53 -0700269
270#check out new version and get information
Martin Rotheb80d8d2022-02-28 14:41:57 -0700271printf -- "\nFinding new submodule versions...\n" >&2
Martin Rothfb190ed2016-10-01 20:13:43 -0600272git checkout "$NEW_GIT_VERSION" > /dev/null 2>&1
Martin Rotheb80d8d2022-02-28 14:41:57 -0700273echo "Git version: $(git log --oneline -n 1)"
Martin Rothbec11082015-11-03 21:01:53 -0700274git submodule update --init --checkout > /dev/null 2>&1
Martin Rothbec11082015-11-03 21:01:53 -0700275
Martin Roth3ce67832017-11-04 18:36:19 -0600276for module in $(git submodule --quiet foreach pwd); do
277 name="$(basename "$module" | sed 's/-/_/g')"
278 version="${name^^}_NEW_VERSION"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700279 declare "$version"="$(get_latest_commit_id "$module")"
Martin Roth3ce67832017-11-04 18:36:19 -0600280done
Martin Rothfb190ed2016-10-01 20:13:43 -0600281
Martin Rotheb80d8d2022-02-28 14:41:57 -0700282echo "Logging directories in the new tree." >&2
Martin Roth3ce67832017-11-04 18:36:19 -0600283mainboard_list_new=$(grep -h "^[[:space:]]*config\>[[:space:]]*\<BOARD_" src/mainboard/*/*/Kconfig.name 2>/dev/null | sed "s,^.*\<BOARD_\([A-Z0-9_]*\)\>.*$,\1," | sort)
284cpu_list_new=$(find_areas "src/cpu" "Kconfig" "intel/common")
Martin Roth50e85792024-01-18 19:10:50 -0700285soc_list_new=$(find_areas "src/soc" "Makefile.mk" "intel/common\|amd/common\|romstage")
Martin Roth3ce67832017-11-04 18:36:19 -0600286northbridge_list_new=$(find_areas "src/northbridge" "Kconfig" "")
Martin Roth50e85792024-01-18 19:10:50 -0700287sio_list_new=$(find_areas "src/superio" "Makefile.mk" "")
Martin Roth3ce67832017-11-04 18:36:19 -0600288southbridge_list_new=$(find_areas "src/southbridge" "Kconfig" "")
289
Martin Rothfb190ed2016-10-01 20:13:43 -0600290printf "Calculating new SLOC\n"
Martin Roth3ce67832017-11-04 18:36:19 -0600291NEW_SLOC=$(get_sloc)
Martin Rothbec11082015-11-03 21:01:53 -0700292
Stefan Reinauer0d3a1fb2023-06-10 12:32:50 -0700293git checkout origin/main > /dev/null 2>&1
Martin Rothbec11082015-11-03 21:01:53 -0700294git submodule update --init --checkout > /dev/null 2>&1
Martin Rothbec11082015-11-03 21:01:53 -0700295trap "" SIGINT
Martin Rotheb80d8d2022-02-28 14:41:57 -0700296
Martin Rothfb190ed2016-10-01 20:13:43 -0600297# Done collecting data from the old and new versions
Martin Rothbec11082015-11-03 21:01:53 -0700298
Martin Rothfb190ed2016-10-01 20:13:43 -0600299# Start outputting to logfile
300echo "Generating release notes from version ${OLD_GIT_VERSION} to ${NEW_GIT_VERSION}"
301echo; echo "Main repo"
302echo "Main repo" >> "$LOGFILE"
Martin Rothbec11082015-11-03 21:01:53 -0700303echo "------------------" >> "$LOGFILE"
Martin Rothfb190ed2016-10-01 20:13:43 -0600304log_versions "$(git log --pretty=%H \
305 "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | tail -1)" \
306 "$(git log --pretty=%H \
307 "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | head -1 )"
308echo "" >> "$LOGFILE"
Martin Rothbec11082015-11-03 21:01:53 -0700309
Martin Roth3ce67832017-11-04 18:36:19 -0600310### SPECIFIC AREAS FOR RELEASE ###
Martin Rotheb80d8d2022-02-28 14:41:57 -0700311get_log_dedupe "Documentation" "Documentation README"
312
313get_log_dedupe "cleanup" "" "add missing\|fix typo\|clean up\|spelling\|Use tabs\|space [around\|before]\|code formatting\|commented code\|code cleanup\|capitalize\|[unnecessary\|unneeded\|trailing] whitespace\|checkpatch\|remove [unused\|dead\|unneeded\|duplicated\|not used]\|[transition away from\|get rid of\|don't use] device_t"
314
315get_log_dedupe "ACPI Changes" "" "ASL 2.0 syntax"
Martin Rothbec11082015-11-03 21:01:53 -0700316
Martin Roth3ce67832017-11-04 18:36:19 -0600317get_log_dedupe "Google Kahlee / AMD Gardenia" "src/mainboard/google/kahlee src/mainboard/amd/gardenia" "kahlee\|gardenia"
318get_log_dedupe "AMD Stoney Ridge" "src/soc/amd/stoneyridge" "stoney"
Martin Rothbec11082015-11-03 21:01:53 -0700319
Martin Rotheb80d8d2022-02-28 14:41:57 -0700320get_log_dedupe "Google Zork / AMD Mandolin / AMD Bilby" "src/mainboard/amd/mandolin src/mainboard/google/zork src/mainboard/amd/bilby" "mandolin\|zork\|bilby"
321get_log_dedupe "AMD Picasso" "src/soc/amd/picasso" "picasso"
322
323get_log_dedupe "Google Guybrush / AMD Majolica" "src/mainboard/google/guybrush src/mainboard/amd/majolica" "majolica\|guybrush"
324get_log_dedupe "AMD cezanne" "src/soc/amd/cezanne" "cezanne"
325
326get_log_dedupe "AMD chausie / Google Skyrim" "src/mainboard/amd/chausie src/mainboard/google/skyrim" "chausie\|skyrim"
327get_log_dedupe "AMD sabrina" "src/soc/amd/sabrina" "sabrina"
328
329get_log_dedupe "Google Brya / Intel adlrvp" "src/mainboard/intel/adlrvp src/mainboard/google/brya" "brya\|adlrvp"
330get_log_dedupe "Intel Alder Lake" "src/soc/intel/alderlake" "alderlake\|adl\|alder lake"
331
332get_log_dedupe "intel Elkhart Lake" "src/soc/intel/elkhartlake" "elkhartlake\|ehl\|elkhart lake"
333
334get_log_dedupe "Google Dedede" "src/mainboard/google/dedede" "dedede"
335get_log_dedupe "intel Jasper Lake" "src/soc/intel/jasperlake" "jasperlake\|jsl\|jasper lake"
336
337get_log_dedupe "Intel Tiger Lake" "src/soc/intel/tigerlake" "tigerlake\|tgl\|tiger lake"
338
339get_log_dedupe "Google Hatch" "src/mainboard/google/hatch" "hatch"
340get_log_dedupe "Intel Comet Lake" "src/soc/intel/cometlake" "cometlake\|cml\|comet lake"
341
Martin Roth3ce67832017-11-04 18:36:19 -0600342get_log_dedupe "Google Eve / Poppy / Fizz / Soraka / Nautilus / Intel KblRvp" "src/mainboard/google/eve src/mainboard/google/poppy src/mainboard/google/fizz src/mainboard/intel/kblrvp" "eve[ :]\|poppy\|fizz\|soraka\|nautilus\|kblrvp"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700343
344get_log_dedupe "Intel Kunimitsu / Google Chell / Lars / Glados" "src/mainboard/google/lars src/mainboard/google/chell src/mainboard/google/glados src/mainboard/intel/kunimitsu" "chell\|lars\|kunimitsu"
Martin Roth3ce67832017-11-04 18:36:19 -0600345get_log_dedupe "Purism SKL" "src/mainboard/purism/librem_skl" "librem13v2\|librem_skl"
346get_log_dedupe "Intel Skylake / Kabylake" "src/soc/intel/skylake" "skylake\|sky.lake\|kabylake\|kaby.lake"
Martin Rothbec11082015-11-03 21:01:53 -0700347
Martin Rotheb80d8d2022-02-28 14:41:57 -0700348get_log_dedupe "Intel Glkrvp / Google Octopus / Bip / Yorp" "src/mainboard/google/octopus src/mainboard/intel/glkrvp" "octopus\|glkrvp|\bip\|yorp"
349
Martin Roth3ce67832017-11-04 18:36:19 -0600350get_log_dedupe "Google Cyan / Intel Strago" "src/mainboard/google/cyan src/mainboard/intel/strago" "cyan\|strago"
351get_log_dedupe "Intel Braswell" "src/soc/intel/braswell" "braswell"
Martin Rothbec11082015-11-03 21:01:53 -0700352
Martin Roth3ce67832017-11-04 18:36:19 -0600353get_log_dedupe "Google Kevin / Gru / Bob / Scarlet / Nefario" "src/mainboard/google/gru" "kevin\|gru[^b]"
354get_log_dedupe "Rockchip rk3399" "src/soc/rockchip/rk3399" "rk3399"
Martin Rothbec11082015-11-03 21:01:53 -0700355
Martin Roth3ce67832017-11-04 18:36:19 -0600356get_log_dedupe "Google Reef / Pyro / Sand / Snappy / Nasher" "src/mainboard/google/reef" "reef\|pyro\|sand[ :]\|snappy\|nasher"
357#get_log_dedupe "Intel apollolake_rvp leafhill minnow3" "src/mainboard/intel/apollolake_rvp src/mainboard/intel/leafhill src/mainboard/intel/minnow3" "apollolake_rvp\|leafhill\|minnow3"
358get_log_dedupe "Siemens mc_apl1" "src/mainboard/siemens/mc_apl1" "mc_apl1"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700359get_log_dedupe "Intel Apollolake/ Geminilake" "src/soc/intel/apollolake" "apollolake\|apollo.lake\|geminilake\|gemini.lake\|apl\|glk"
Martin Rothbec11082015-11-03 21:01:53 -0700360
Martin Rotheb80d8d2022-02-28 14:41:57 -0700361get_log_dedupe "Google Zoombini / Intel cannonlake_rvp" "src/mainboard/google/zoombini src/mainboard/intel/cannonlake_rvp" "zoombini\|cannonlake_rvp"
Martin Roth3ce67832017-11-04 18:36:19 -0600362get_log_dedupe "Intel CannonLake" "src/soc/intel/cannonlake src/mainboard/intel/cannonlake_rvp" "cannonlake"
Martin Rothfb190ed2016-10-01 20:13:43 -0600363
Martin Rotheb80d8d2022-02-28 14:41:57 -0700364get_log_dedupe "Google Kuki" "src/mainboard/google/kukui" "kukui"
365get_log_dedupe "mediatek/mt8183" "src/soc/mediatek/mt8183" "mt8183"
366
367get_log_dedupe "Google Cheza" "src/mainboard/google/cheza" "cheza"
368get_log_dedupe "Qualcomm sdm845" "src/soc/qualcomm/sdm845" "sdm845"
369
370get_log_dedupe "Prodrive Hermes / Google Sarien / Intel coffeelake_rvp" "src/mainboard/intel/coffeelake_rvp src/mainboard/google/sarien src/mainboard/prodrive/hermes"
371get_log_dedupe "Intel Coffeelake" "soc/intel/coffeelake"
372
Martin Rotheb80d8d2022-02-28 14:41:57 -0700373get_log_dedupe "Cavium" "src/soc/cavium src/mainboard/cavium src/mainboard/opencellular/elgon "
374get_log_dedupe "Scaleway Tagada" "src/mainboard/scaleway/tagada" "tagada"
375
Martin Roth3ce67832017-11-04 18:36:19 -0600376get_log_dedupe "Intel Galileo" "src/mainboard/intel/galileo" "galileo"
377get_log_dedupe "Intel Quark" "src/soc/intel/quark" "quark"
Martin Rothfb190ed2016-10-01 20:13:43 -0600378
Martin Roth3ce67832017-11-04 18:36:19 -0600379get_log_dedupe "Intel Baytrail" "src/soc/intel/baytrail" "baytrail"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700380get_log_dedupe "Google Gale / Qualcomm QX ipq40xx" "src/mainboard/google/gale src/soc/qualcomm/ipq40xx" "gale\|ipq40"
381get_log_dedupe "Google Rotor / Marvell Mvmap2315" "src/soc/marvell/mvmap2315 src/mainboard/google/rotor" "marvell\|mvmap\|rotor"
Martin Rothfb190ed2016-10-01 20:13:43 -0600382
Martin Roth3ce67832017-11-04 18:36:19 -0600383get_log_dedupe "Gigabyte ga-g41m-es2l" "src/mainboard/gigabyte/ga-g41m-es2l" "es2l"
384get_log_dedupe "Intel x4x northbridge / LGA775" "src/northbridge/intel/x4x src/cpu/intel/socket_LGA775" "x4x\|lga775"
Martin Rothfb190ed2016-10-01 20:13:43 -0600385
Martin Rotheb80d8d2022-02-28 14:41:57 -0700386get_log_dedupe "Intel Haswell / Broadwell" "src/northbridge/haswell" "haswell"
387get_log_dedupe "Intel Lynxpoint" "src/southbridge/intel/lynxpoint" "lynxpoint"
388
Martin Roth3ce67832017-11-04 18:36:19 -0600389get_log_dedupe "Intel Sandybridge / Ivybridge" "src/southbridge/intel/bd82x6x src/southbridge/intel/fsp_bd82x6x src/northbridge/intel/sandybridge src/northbridge/intel/fsp_sandybridge src/cpu/intel/fsp_model_206ax src/cpu/intel/model_206ax" "sandybridge\|ivybridge\|bd82x6x"
Martin Rothfb190ed2016-10-01 20:13:43 -0600390
Martin Rotheb80d8d2022-02-28 14:41:57 -0700391get_log_dedupe "Google Herbrine" "src/mainboard/google/herobrine" "herobrine"
392get_log_dedupe "Qualcomm SC7280" "src/soc/qualcomm/sc2780" "sc2780"
393
394get_log_dedupe "Google Corsola" "src/mainboard/google/corsola" "corsola"
395get_log_dedupe "Mediatek MT8186" "src/soc/mediatek/mt8186" "mt8186"
396
Martin Roth3ce67832017-11-04 18:36:19 -0600397get_log_dedupe "Intel Common" "src/soc/intel/common src/southbridge/intel/common src/northbridge/intel/common" ""
398get_log_dedupe "Amd Common" "src/soc/amd/common src/southbridge/amd/common" ""
399
Patrick Georgi3b34ef22019-06-30 11:41:51 +0200400get_log_dedupe "Nvidia" "src/southbridge/nvidia" ""
401get_log_dedupe "Via" "src/northbridge/via src/southbridge/via" ""
402get_log_dedupe "Broadcom" "src/southbridge/broadcom" ""
403get_log_dedupe "Qualcomm" "src/soc/qualcomm" ""
Martin Rotheb80d8d2022-02-28 14:41:57 -0700404get_log_dedupe "Mediatek" "src/soc/mediatek" ""
Patrick Georgi3b34ef22019-06-30 11:41:51 +0200405
Martin Roth3ce67832017-11-04 18:36:19 -0600406get_log_dedupe "Intel vendorcode / FSP" "src/drivers/intel/fsp* src/vendorcode/intel" ""
Martin Rotheb80d8d2022-02-28 14:41:57 -0700407get_log_dedupe "AMD vendorcode / AGESA / PI" "src/vendorcode/amd" "agesa\|binarypi"
Martin Roth3ce67832017-11-04 18:36:19 -0600408get_log_dedupe "Google vendorcode" "src/vendorcode/google"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700409get_log_dedupe "Cavium vendorcode" "src/vendorcode/cavium"
Martin Roth3ce67832017-11-04 18:36:19 -0600410
Martin Rotheb80d8d2022-02-28 14:41:57 -0700411get_log_dedupe "Security" "src/drivers/i2c/tpm src/security" "tpm"
Martin Roth3ce67832017-11-04 18:36:19 -0600412get_log_dedupe "Vboot" "src/vboot" "vboot"
413
414
415### GENERAL AREAS FOR RELEASE ###
416# shellcheck disable=SC2013
417{
Martin Rotheb80d8d2022-02-28 14:41:57 -0700418
419get_log_dedupe "X86 intel" \
420 "src/cpu/intel src/soc/intel src/northbridge/intel \
421 src/southbridge/intel src/include/intel src/drivers/intel"
422
423get_log_dedupe "X86 AMD" \
424 "src/cpu/amd src/northbridge/amd src/southbridge/amd src/include/amd src/soc/amd" \
425 "agesa\|binarypi\|binary.pi"
426
427get_log_dedupe "X86 common" \
428 "src/arch/x86 src/cpu/x86 src/include/x86 src/include/pc80"
429
Martin Roth3ce67832017-11-04 18:36:19 -0600430get_log_dedupe "ARM" \
431 "$(for codedir in $(grep -rl "_ARM" --include=Kconfig | \
432 grep -v 'src/mainboard\|payloads/\|drivers/\|vendorcode/\|console' ); \
433 do dirname "$codedir"; done | grep -v '^src$')"
434
435get_log_dedupe "RISC-V" \
436 "$(for codedir in $(grep -rl "_RISCV" --include=Kconfig | grep -v 'payloads/\|drivers/\|vendorcode/\|console' ); do dirname "$codedir"; done | grep -v '^src$')" \
Martin Rotheb80d8d2022-02-28 14:41:57 -0700437 "riscv\|risc-v\|lowrisc\|sifive"
Martin Roth3ce67832017-11-04 18:36:19 -0600438}
439
Martin Rotheb80d8d2022-02-28 14:41:57 -0700440get_log_dedupe "Google Mainboards" "src/mainboard/google"
441get_log_dedupe "Intel Mainboards" "src/mainboard/intel"
442get_log_dedupe "AMD Mainboards" "src/mainboard/amd"
Martin Roth3ce67832017-11-04 18:36:19 -0600443get_log_dedupe "Mainboards" "src/mainboard/"
444
445# Next, print all the rest of the specific areas
446get_log_dedupe "ACPI" "src/acpi/"
447get_log_dedupe "Console" "src/console src/include/console"
448get_log_dedupe "SuperIO" "src/superio src/include/superio"
449get_log_dedupe "EC" "src/ec"
450get_log_dedupe "Drivers" "src/drivers"
451get_log_dedupe "Devices" "src/device src/include/device"
452
453# 5th, print the generic areas - This goes late so that the specific
454# area changes will catch any commits in these areas first.
455get_log_dedupe "Toolchain" "util/crossgcc"
456get_log_dedupe "cbfstool" "util/cbfstool"
457get_log_dedupe "Lint tools" "util/lint"
458get_log_dedupe "Lib" "src/lib"
459get_log_dedupe "Commonlib" "src/commonlib"
460get_log_dedupe "Include" "src/include"
461get_log_dedupe "Utilities" "util"
462get_log_dedupe "Payloads" "payloads"
463get_log_dedupe "Vendorcode" "src/vendorcode"
Martin Roth3ce67832017-11-04 18:36:19 -0600464
465# Then look at areas that are usually outside the mainboards and architectures
466get_log_dedupe "Build system" \
Martin Roth50e85792024-01-18 19:10:50 -0700467 "Makefile Makefile.mk toolchain.mk src/Kconfig src/cpu/Makefile.mk"
Martin Roth3ce67832017-11-04 18:36:19 -0600468
469get_log_dedupe "Submodules" "3rdparty util/nvidia/cbootimage"
Patrick Georgi3b34ef22019-06-30 11:41:51 +0200470
471get_log_dedupe "Maintainers" "MAINTAINERS" ""
472
Martin Roth3ce67832017-11-04 18:36:19 -0600473# Finally, get anything that was missed above
474get_log_dedupe "MISC" "."
475
Patrick Georgi1916d682019-11-20 16:05:21 +0100476# Replace VENDOR_DEVICE from stdin with their nice names on stdout
477real_mainboard_names() {
478 local tree_version=$1 # "old" or "new"
479 local git_version_var=${tree_version^^}_GIT_VERSION
480 local git_version=${!git_version_var}
481 local line
Martin Rotheb80d8d2022-02-28 14:41:57 -0700482 local file
483 local vendor
Patrick Georgi1916d682019-11-20 16:05:21 +0100484
Martin Rotheb80d8d2022-02-28 14:41:57 -0700485 while read -r line; do
486 file="$(git grep -l "^[[:space:]]*config\>[[:space:]]*\<BOARD_${line}\$" "${git_version}" -- src/mainboard/\*/\*/Kconfig.name | sed "s,^${git_version}:,,")"
Patrick Georgi1916d682019-11-20 16:05:21 +0100487 if [ -z "$file" ]; then
488 echo "This shouldn't happen: couldn't find Kconfig for $line"
489 exit 1
490 fi
Martin Rotheb80d8d2022-02-28 14:41:57 -0700491 vendor="$(git grep \" "${git_version}" -- "$(echo "${file}" | cut -d/ -f1-3,5)" | cut -d\" -f2)"
492 git grep -h -A1 "^[[:space:]]*config\>[[:space:]]*\<BOARD_${line}\$" "${git_version}" -- "${file}" | grep \" |cut -d\" -f2 |sed "s,^,${vendor} ,"
Patrick Georgi1916d682019-11-20 16:05:21 +0100493 done
494}
495
Martin Roth3ce67832017-11-04 18:36:19 -0600496# Show areas that have been added or removed
Patrick Georgi1916d682019-11-20 16:05:21 +0100497show_diff "mainboards" "$mainboard_list_old" "$mainboard_list_new" real_mainboard_names
Martin Roth3ce67832017-11-04 18:36:19 -0600498show_diff "processors" "$cpu_list_old" "$cpu_list_new"
499show_diff "socs" "$soc_list_old" "$soc_list_new"
500show_diff "northbridges" "$northbridge_list_old" "$northbridge_list_new"
501show_diff "southbridges" "$southbridge_list_old" "$southbridge_list_new"
502show_diff "sios" "$sio_list_old" "$sio_list_new"
503
504# Log submodules
505printf "Submodules\n----------\n" >> "$LOGFILE"
506for module in $(git submodule --quiet foreach pwd); do
507 name=$(basename "$module")
Martin Rotheb80d8d2022-02-28 14:41:57 -0700508 module="$(realpath "${module}")"
509 workingdir="$(realpath "${PWD}")"
Martin Roth3ce67832017-11-04 18:36:19 -0600510 # shellcheck disable=SC2001
Martin Rotheb80d8d2022-02-28 14:41:57 -0700511 path=${module#"$workingdir"}
Martin Roth3ce67832017-11-04 18:36:19 -0600512 old_version=$(echo "${name^^}_OLD_VERSION" | sed 's/-/_/g')
513 new_version=$(echo "${name^^}_NEW_VERSION" | sed 's/-/_/g')
Martin Rotheb80d8d2022-02-28 14:41:57 -0700514 get_log_submodule "${!old_version}" "${!new_version}" "${path}"
Martin Roth3ce67832017-11-04 18:36:19 -0600515done
Martin Rothbec11082015-11-03 21:01:53 -0700516
Martin Rothfb190ed2016-10-01 20:13:43 -0600517printf "\nrepo statistics\n-------------------\n" >> "$LOGFILE"
518before_names="$(mktemp "OLDNAMES.XXXX")"
519after_names="$(mktemp "NEWNAMES.XXXX")"
520NEW_AUTHORS=$(git log --pretty=%an "${OLD_GIT_VERSION}" 2>/dev/null | sort | \
521 uniq > "$before_names" && \
522 git log --pretty=%an "${NEW_GIT_VERSION}" 2>/dev/null | \
523 sort | uniq > "$after_names" && \
524 grep -Fxv -c -f "$before_names" "$after_names")
Patrick Georgid653e492019-11-20 16:49:41 +0100525NEW_AUTHOR_LIST=$( grep -Fxv -f "$before_names" "$after_names")
526rm -f "$before_names" "$after_names"
Martin Rothfb190ed2016-10-01 20:13:43 -0600527{
Martin Rothcbc792c2023-08-20 19:21:55 -0600528 printf -- "* Total commits: %s\n" "$TOTAL_COMMITS"
529 printf -- "* Total authors: %s\n" \
Martin Rothfb190ed2016-10-01 20:13:43 -0600530 "$(git log "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | \
531 grep -e '^Author:' | sed 's/.*Author: //' | sed 's/ <.*.>//' | \
532 sort | uniq | wc -l)"
Martin Rothcbc792c2023-08-20 19:21:55 -0600533 printf -- "* New authors: %s\n\nNew Authors:\n%s\n" "$NEW_AUTHORS" \
Martin Rothfb190ed2016-10-01 20:13:43 -0600534 "$NEW_AUTHOR_LIST"
535} >> "$LOGFILE"
Martin Rothbec11082015-11-03 21:01:53 -0700536
Martin Rothfb190ed2016-10-01 20:13:43 -0600537printf "Getting developer list\n"
538printf "\n%-40s: %5s\n" "Developer" "Commits" >> "$LOGFILE"
539git log "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | grep '^Author: ' | \
540 sed 's|Author: ||' | sed 's|\s<.*||' | sort | uniq | \
541 while read -r line; do
Martin Rothcbc792c2023-08-20 19:21:55 -0600542 printf "* %-40s: %5s %5s\n" "$line" \
Martin Rothfb190ed2016-10-01 20:13:43 -0600543 "$(git log "${OLD_GIT_VERSION}" 2>/dev/null | \
544 grep -c "^Author: ${line} <")" \
545 "$(git log "${NEW_GIT_VERSION}" 2>/dev/null | \
546 grep -c "^Author: ${line} <")" >> "$LOGFILE";
547 done
Martin Rothbec11082015-11-03 21:01:53 -0700548
549printf "\nOld SLOC (%s)\n%s" "$NOW" "$OLD_SLOC" >> "$LOGFILE"
550printf "\nNew SLOC (%s)\n%s" "$NOW" "$NEW_SLOC" >> "$LOGFILE"
551
552# Add the collected data to the top of the existing logfile for parsing
553if [ -n "$UPDATE_MAIN_LOGFILE" ]; then
554 tmpfile="$(mktemp "LOGFILE.XXXX")"
555 grep -Fxv -f "$MAIN_LOGFILE" "$LOGFILE" > "$tmpfile"
556 printf "\n\n" >> "$tmpfile"
557 cat "$MAIN_LOGFILE" >> "$tmpfile"
558 mv "$tmpfile" "$MAIN_LOGFILE"
559 rm -f "$LOGFILE"
560fi
Martin Rothfb190ed2016-10-01 20:13:43 -0600561
562printf "Done.\n"